/**
  *The <I>main</I> function class for this program.<BR>
  *Developed for Mark Boshart's CSC2020 class.
  *@author Sumit Khanna and Bryce Luffman.
  */

import java.io.File; //imports a file object to test args


//Table of errors:
//3 - listed bellow, invalid usage or command args
//2 - clicked cancle when asked what type of graph they wanted, assumed they wanted to exit


public class GraphMapper
{

    //about statement :-)
    public static final String ABOUT = "GraphMapper\n" +
    "v1.0\n"+
    "Developed by Sumit Khanna and Bryce Luffman for a CSC 202 project.\n" +
    "Special thanks to Marc Santoro for his trig calculations.\n" +
    "100% GNU GPL.";

    public static void main (String[] args)
    {
      if(args.length == 1) //if they endered in one filename
       {

          GraphGUI gui = new GraphGUI(new File(args[0]));
          //we're goint to pass the file without checking it. We'll
          //let the graphical components handle the error message
          gui.setSize(640,480);
          gui.show();
       }
       else if(args.length > 1) //too many arguments
       {
          System.out.println("\n\n" + "GraphMapper v1.0\n\n" +
                             "Usage: java GraphMapper <file>\n\n");
          System.exit(3); //exit>0 is an error. I used 2 somehwere else so 3 is good :)
       }
       else{  //no args passed
       GraphGUI gui = new GraphGUI(null);
       gui.setSize(640,480);
       gui.show();
       }
    }
}
