package queue;

public class Queue 
{
  //only next references, not circular
  private Node head;
  private Node tail;
  private int size;

  public Queue() 
  { 
    head = null;
    tail = null;
    size=0;
  }  // end default constructor

  public int size()
  { 
     return size;
  }
  
  // queue operations:
  public boolean isEmpty() 
  {
    return head == null;
  }  // end isEmpty

  public void dequeueAll() 
  {
    head = null;
    tail = null;
    size=0;
  }  // end dequeueAll

  public void enqueue(Object newItem) 
  {
    Node newNode = new Node(newItem);

    // insert the new node
    if (isEmpty()) 
    {
      // insertion into empty queue
      head = newNode;
      tail = newNode;
    }
    else 
    {
      // insertion into nonempty queue
      newNode.setNext(null);
      tail.setNext(newNode);
      tail = newNode;
    }  // end if
    size++;

  }  // end enqueue

  public Object dequeue() throws QueueException 
  {
    Object myObject;

    if (!isEmpty()) 
    {
      // queue is not empty; remove front
      myObject=head.getItem();
      if (head == tail) 
      { // special case--  now queue is empty
        head = null;        
        tail = null;
      }
      else 
      {
        head = head.getNext();
      }  // end if
      size--;
      return myObject;
    }
    else 
    {
      throw new QueueException("QueueException on dequeue: queue empty");
    }  // end if
  }  // end dequeue

  public Object peek() throws QueueException 
  {
    Object myObject;
    if (!isEmpty()) 
    {  
      // queue is not empty; retrieve front
      myObject = head.getItem();
      return myObject;
    }
    else 
    {
      throw new QueueException("QueueException on peek: queue empty");
    }  // end if
  }  // end peek
   
} // end QueueReferenceBased3
